
; Includes
#include <Array.au3>
#include "DllStruct.au3"

; Vars
Global $vTest, $aPtr[8], $iTmp

; Try the following a few times
For $i = 0 To 7 Step 1

	; Get a DllStruct's Ptr
	$aPtr[$i] = _StructByPtr()

	; Create a Struct at this Place to access data
	$vTest = DllStructCreate('int[1]',$aPtr[$i])

	; Output the read content
	ConsoleWrite('Read content: ' & DllStructGetData($vTest, 1, 1) & @CRLF & @CRLF)

Next

; Delete every Struct to clear Memory
For $i = 0 To 7 Step 1

	; Delete the Struct via Ptr
	$iTmp = _DllStructDeleteByPtr($aPtr[$i])

	; Output errors
	ConsoleWrite($i & ' Errorcode: ' & @error & @CRLF)

Next

ConsoleWrite(@CRLF)

; Get a Struct's Ptr
Func _StructByPtr()

	; Create the Struct
	Local $vStruct = DllStructCreate('int[1]'), $iPointer

	; Set its data
	DllStructSetData($vStruct, 1, Random(1000,9999,1), 1)

	; Output its data (for comparison)
	ConsoleWrite('Original: ' & DllStructGetData($vStruct, 1, 1) & @CRLF)

	; Save the Struct
	_DllStructSave($vStruct) ; Try the Script without this line !

	; Return its ptr
	Return DllStructGetPtr($vStruct)

EndFunc